package cn.ibizlab.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.sample.domain.IBIZTASKTEAM;
import cn.ibizlab.core.sample.filter.IBIZTASKTEAMSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBIZTASKTEAM] 服务对象接口
 */
public interface IIBIZTASKTEAMService extends IService<IBIZTASKTEAM> {

    boolean create(IBIZTASKTEAM et);
    void createBatch(List<IBIZTASKTEAM> list);
    boolean update(IBIZTASKTEAM et);
    void updateBatch(List<IBIZTASKTEAM> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    IBIZTASKTEAM get(String key);
    IBIZTASKTEAM getDraft(IBIZTASKTEAM et);
    boolean checkKey(IBIZTASKTEAM et);
    boolean save(IBIZTASKTEAM et);
    void saveBatch(List<IBIZTASKTEAM> list);
    Page<IBIZTASKTEAM> searchDefault(IBIZTASKTEAMSearchContext context);
    List<IBIZTASKTEAM> selectByRoot(String ibiztaskid);
    void removeByRoot(String ibiztaskid);
    void saveByRoot(String ibiztaskid, List<IBIZTASKTEAM> list) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBIZTASKTEAM> getIbiztaskteamByIds(List<String> ids);
    List<IBIZTASKTEAM> getIbiztaskteamByEntities(List<IBIZTASKTEAM> entities);
}


